package koeln.uni.idh.java1.session11.zoo;

public class Util {

	/**
	 * Scales x to the range of min to max.
	 * 
	 * @param x   the value to scale
	 * @param min the minimum value of the new range
	 * @param max the maximum value of the new range
	 * @return The scaled value
	 */
	public static int scale(double x, int min, int max) {
		return (min + (int) (x * (max - min)));
	}

	/**
	 * Checks wether an int value is contained in an array of int values. Returns
	 * true if this is the case.
	 * 
	 * @param arr The array to search
	 * @param element The element that we are looking for
	 * @return true or false
	 */
	public static boolean contains(int[] arr, int element) {
		for (int j = 0; j < arr.length; j++) {
			if (element == arr[j])
				return true;
		}
		return false;

	}

	/**
	 * Returns a random integer number between the given parameters.
	 * 
	 * @param min The minimum value
	 * @param max The maximum value
	 * @return A random value
	 */
	public static int randInt(int min, int max) {
		return scale(Math.random(), min, max);
	}
}
