package koeln.uni.idh.java1.session11.zoo;

import koeln.uni.idh.java1.session11.zoo.ui.AsciiImage;
import koeln.uni.idh.java1.session11.zoo.animals.Alpaca;
import koeln.uni.idh.java1.session11.zoo.animals.Animal;
import koeln.uni.idh.java1.session11.zoo.animals.Horse;

public class Zoo {

	public static String[] names = new String[] { "Alexandra", "Alice", "Aline", "Anastasia", "Ander", "Andrea",
			"Andreas", "Anja", "Anke", "Ann", "Anna", "Anne", "Antor", "Aria", "Astrid", "Axel", "Barbara", "Beatrice",
			"Beatrix", "Benjamin", "Bettina", "Bieke Verle", "Birgit", "Björn", "Carlo", "Catherine", "Christian",
			"Christiane", "Christine", "Christof", "Christoph", "Claudia", "Daniel", "Dany", "David", "Debora",
			"Dennis", "Dominik", "Eckhard", "Edwin", "Eleftheria", "Esther", "Etienne", "Eugen", "Fabian", "Federico",
			"Felix", "Fiorella", "Folkart", "Frank", "Gabriele", "Gabriella", "Gesine", "Gisa", "Gudrun", "Habbo",
			"Hans-Joachim", "Hans-Peter", "Heidrun", "Heike", "Heinz", "Isolde", "Jan Felix", "Joachim", "Jörg",
			"Judith", "Julia", "Jürgen", "Karl", "Katajun", "Katharina", "Klaus", "Kristina", "Magnus", "Marco",
			"Marcus", "Maren Janika", "Maria-Theresia", "Marina", "Marita", "Martin", "Martine", "Michael", "Michaela",
			"Monika", "Nadine", "Nicolas", "Nicole", "Nikolaus", "Nikolaus P.", "Nils", "Nora", "Øyvind", "Paul",
			"Peter", "Peter Franz", "Peter W.", "Peter Werner", "Petra", "Ralph", "René", "Richard", "Rie", "Roman",
			"Ruth", "Sabine", "Sandra", "Sebastian", "Sebastião", "Sieglinde", "Silke", "Silviane", "Sophie", "Stefan",
			"Stephan", "Stephan Michael", "Susanne", "Susanne Katrin", "Sven", "Thiemo", "Thiemo Rafael", "Thomas",
			"Thoralf", "Thorsten", "Tobias", "Torsten", "Ulrike", "Ute", "Walter", "Werner", "Wiebke", "Wilfried",
			"Wolfgang", "Wolfram" };

	Animal[] animals;

	int size;

	int round = 0;

	public Zoo(int size, int numberOfAnimals) {
		this.size = size;

		// generate and position animals
		this.animals = new Animal[numberOfAnimals];
		for (int a = 0; a < this.animals.length; a++) {
			if (Math.random() < 0.5)
				this.animals[a] = new Horse(this, names[Util.randInt(0, names.length)], getRandomFreePosition());
			// else if (Math.random() > 0.9)
			// this.animals[a] = new Animal(names[Util.randInt(0, names.length)]);
			else
				this.animals[a] = new Alpaca(this, names[Util.randInt(0, names.length)], getRandomFreePosition());

		}
	}

	public void draw() {
		AsciiImage ai = new AsciiImage(size, size);
		for (int h = 0; h < animals.length; h++) {
			ai.dot(animals[h].getX(), animals[h].getY(), animals[h]);
		}
		System.out.println(ai);
	}

	public static void main(String[] args) {
		Zoo zoo = new Zoo(15, 3);
		do {
			zoo.tick();
		} while(zoo.animals.length < 15*15);
		zoo.draw();
	}

	public Animal getAnimalByPosition(int[] position) {
		for (int a = 0; a < animals.length; a++) {
			if (animals[a] != null && animals[a].getX() == position[0] && animals[a].getY()==position[1])
				return animals[a];
		}
		return null;
	}
	
	public void addAnimal(Animal animal) {
		Animal[] newAnimals = new Animal[animals.length+1];
		int a = 0;
		for (; a < animals.length; a++) {
			newAnimals[a] = animals[a];
		}
		newAnimals[a] = animal;
		this.animals = newAnimals;
	}
	
	public boolean isFree(int[] position) {
		if (position[0] < 0 || position[0] > size - 1)
			return false;
		if (position[1] < 0 || position[1] > size - 1)
			return false;
		for (int a = 0; a < animals.length; a++) {
			if (animals[a] != null)
				if (animals[a].getX() == position[0] && animals[a].getY() == position[1])
					return false;
		}
		return true;
	}

	public int[] getRandomFreePosition() {
		int[] pos = new int[2];
		do {
			pos = new int[] { Util.randInt(1, size - 1), Util.randInt(1, size - 1) };
		} while (!isFree(pos));

		return pos;
	}
	
	public void tick() {
		round++;
		System.out.println("===================");
		System.out.println("     Round " + round);
		System.out.println("===================");
		for (int a = 0; a < animals.length; a++) {
			this.animals[a].tick();
		}
		this.draw();
	}

}
