package koeln.uni.idh.java1.session11.zoo.animals;

import koeln.uni.idh.java1.session11.zoo.Util;
import koeln.uni.idh.java1.session11.zoo.Zoo;

public class Horse extends Animal {
	
	


	public Horse(Zoo zoo, String name, int[] initialPosition) {
		super(zoo, name, initialPosition);
	}


	public char getSymbol() {
		switch(direction) {
		case 0: return '⇐';
		case 1: return '⇑';
		case 2: return '⇒';
		case 3: return '⇓';
		}
		return 'H';
	}


	
	
	@Override
	public Animal reproduce(Animal partner) {
		if (partner instanceof Horse)
			return new Horse(zoo, Zoo.names[Util.randInt(0, Zoo.names.length)], getFreePositionThatIsClose());
		return null;
	}


	@Override
	public int getStepSize() {
		return 2;
	}


	@Override
	public boolean canReproduce(Animal other) {
		return other instanceof Horse;
	}

}
